.e2e_test_job_definition:
  image: python:3-bullseye
  variables:
    E2E_BRANCH: master
    BENCHMARK: "false"
    E2E_REPO_NAME: book-api-e2e-test
    E2E_REPO_URL: "https://gitlab.com/mobica-workshops/examples/python/pytest/$E2E_REPO_NAME.git"
    TEST_MARKERS: "" # supports pytest markerds defined in ex-e2e-api-test-framework framework
  artifacts:
    expire_in: 1 week
    reports:
      junit: junit.xml
    paths:
      - junit.xml
  before_script: |
    git clone $E2E_REPO_URL \
      -b $E2E_BRANCH \
      ../$E2E_REPO_NAME
    cd ../$E2E_REPO_NAME
    apt update -y
    apt install -y python3-venv
    python3 -m venv .venv
    ./.venv/bin/pip3 install -r requirements.txt
    TIMEOUT=360
    until curl http://$APP_NAME:8080/v1/health > /dev/null 2>&1; do
      if [ $TIMEOUT -lt 0 ]; then
        exit 1
      fi
      TIMEOUT=$((TIMEOUT-1))
      sleep 1
    done
  script: |
    if [ "$BENCHMARK" = true ]; then
      . .venv/bin/activate
      pytest --host http://$APP_NAME --port 8080 -m "${TEST_MARKERS}" --benchmark-histogram --junitxml=junit.xml
      find .  -iregex ".*benchmark.*\.svg" -exec cp "{}" $CI_PROJECT_DIR/ \;
      cp `pwd`/junit.xml $CI_PROJECT_DIR/
    else
      pytest --host http://$APP_NAME --port 8080 -m "${TEST_MARKERS}" --junitxml=junit.xml
      cp `pwd`/junit.xml $CI_PROJECT_DIR/
    fi
